#ifndef HEAP_H
#define HEAP_H

#include "int32.h"
#include <pari/pari.h>

struct heap_entry {
  int apos;
  int32 b;
  GEN sum;
} ;

/* insert h[0], delete h[j] */
static inline void heap_permute(struct heap_entry *h,int j,int n)
{
  int p;
  int q;

  q = j;

  while ((p = q << 1) < n) {
    if (cmpii(h[p + 1].sum, h[p].sum) < 0) ++p;
    h[q] = h[p]; q = p;
  }
  if (p == n) {
    h[q] = h[p]; q = p;
  }
  while ((q > j) && (cmpii(h[0].sum, h[p = q >> 1].sum)) < 0) {
    h[q] = h[p]; q = p;
  }
  h[q] = h[0];
}

#endif
