#include "sortedpq.h"
#include "solvepqrs.h"

#define RECORD 100
static int32 record1[RECORD];
static int32 record2[RECORD];

static struct sortedpq ab;
static struct sortedpq cd;

int solvepqrs(
  int alen,int32 *ai, GEN *pa,
  int blen,int32 *bi, GEN *qb,
  int clen,int32 *ci, GEN *rc,
  int dlen,int32 *di, GEN *sd,
  GEN min, int intprec,
  void (*soln)(int32,int32,int32,int32))
{
  int32 a;
  int32 b;
  int32 c;
  int32 d;
  GEN abval;
  GEN cdval;
  GEN recordval;
  int recordlen;
  int j;

  long ltop2, ltop = avma;

  if (!sortedpq_init(&ab,alen,ai,pa,blen,bi,qb,min,intprec)) { 
    avma = ltop; return -1; 
  }
  if (!sortedpq_init(&cd,clen,ci,rc,dlen,di,sd,min,intprec)) {
    avma = ltop; return -1;
  }
  
  if (!sortedpq_next(&ab,&a,&b,&abval)) { avma = ltop; return 0; }
  if (!sortedpq_next(&cd,&c,&d,&cdval)) { avma = ltop; return 0; }

  for (;;) {
    while (cmpii(cdval, abval) < 0)
      if (!sortedpq_next(&cd,&c,&d,&cdval)) { avma = ltop; return 0; }
    if (cmpii(cdval, abval) > 0) {
      if (!sortedpq_next(&ab,&a,&b,&abval)) { avma = ltop; return 0; }
      continue;
    }

    recordlen = 0;
    ltop2 = avma;
    recordval = gcopy(abval);
    do {
      if (recordlen == RECORD) return -1;
      record1[recordlen] = c;
      record2[recordlen] = d;
      ++recordlen;

      if (!sortedpq_next(&cd,&c,&d,&cdval)) {
        do {
          for (j = 0;j < recordlen;++j)
	    soln(a,b,record1[j],record2[j]);
          if (!sortedpq_next(&ab,&a,&b,&abval)) { avma = ltop; return 0; }
        } while (cmpii(abval, recordval) == 0);
	avma = ltop; return 0;
      }
    } while (cmpii(cdval, recordval) == 0);

    do {
      for (j = 0;j < recordlen;++j)
	soln(a,b,record1[j],record2[j]);
      if (!sortedpq_next(&ab,&a,&b,&abval)) { avma = ltop; return 0; }
    } while (cmpii(abval, recordval) == 0);
    avma = ltop2;
  }
  
  avma = ltop;
}
