#include "sortedpq.h"
#include "heap.h"

int sortedpq_init(struct sortedpq *x, int alen, int32 *a, GEN *pa, 
		  int blen,int32 *b, GEN *qb, GEN min, int intprec)
{
  int j;
  int p;
  int q;
  int c;
  int n;
  GEN minqb;
  struct heap_entry *h;

  long ltop;

  h = (struct heap_entry *) malloc((blen + 1) * sizeof(*h));
  if (!h) return 0;
  n = 0;

  x->sum = cgeti(intprec);

  for (j = 0;j < blen;++j) {
    ltop = avma;
    minqb = subii(min, qb[j]);

    p = 0;
    q = alen;
    while (p < q) {
      c = (p + q) / 2;
      if (cmpii(minqb, pa[c]) <= 0) q = c; else p = c + 1;
    }

    if (q < alen) {
      ++n;
      h[n].b = b[j];
      h[n].apos = q;
      h[n].sum = gerepileupto(ltop, cgeti(intprec));
      addiiz(qb[j], pa[q], h[n].sum);
    }
  }

  x->heap = h;
  x->heaplen = n;
  x->alen = alen;
  x->a = a;
  x->pa = pa;

  j = n / 2 + 1;
  while (j > 1) {
    --j;
    h[0] = h[j];
    heap_permute(h,j,n);
  }

  return 1;
}

int sortedpq_next(struct sortedpq *x, int32 *a, int32 *b, GEN *sum)
{
  struct heap_entry *h;
  int n;
  int apos;
  long ltop;
  GEN g;

  n = x->heaplen;
  if (!n) return 0;
  h = x->heap;

  apos = h[1].apos;

  *a = x->a[apos];
  *b = h[1].b;
  affii(h[1].sum, x->sum);
  *sum = x->sum;

  ++apos;
  if (apos < x->alen) {
    h[0].apos = apos;
    h[0].b = h[1].b;
    ltop = avma;
    g = addii(subii(h[1].sum, x->pa[apos - 1]), x->pa[apos]);
    if(lgefint(g) > lg(h[0].sum))
      fprintferr("intprec = %d, but we've produced an integer of length %d."
	  "\nIt is %Z (a = %ld, b = %ld, h[1].sum = %Z)\n", lg(h[0].sum), 
	  lgefint(g), g, apos, h[0].b, h[1].sum);
    h[0].sum = h[1].sum; affii(g, h[0].sum); 
    avma = ltop;
    heap_permute(h,1,n);
    return 1;
  }

  h[0] = h[n];
  --n;
  x->heaplen = n;
  heap_permute(h,1,n);
  return 1;
}
